//
//  ViewController.m
//  TestPattern
//
//  Created by lotco on 2016. 3. 16..
//  Copyright © 2016년 lotco. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()

@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}
#pragma mark - util
- (UIColor *) randomColor{
    
    float red = arc4random() %255+1;
    float green = arc4random() %255+1;
    float blue = arc4random() %255+1;
    float alpha = arc4random() %255+1;
    
    red = red / 255.0;
    green = green / 255.0;
    blue = blue / 255.0;
    alpha = alpha / 255.0;
    
    return [UIColor colorWithRed:red green:green blue:blue alpha:alpha];
}

#pragma mark - IBAction
- (IBAction)addDelegateViewButtonAction:(id)sender {
    delegateViewController = [self.storyboard instantiateViewControllerWithIdentifier:@"TPDelegateViewController"];
    delegateViewController.view.frame = CGRectMake(20, 140, 300, 500);
    delegateViewController.view.backgroundColor = [self randomColor];

    //객체를 생성한후 델리게이트 설정을 해줘야만 해당 객체를 통해 값을 전달 받을 수 있다.
    delegateViewController.delegate = self;
    
    [self.view addSubview:delegateViewController.view];
}

#pragma mark - TPDelegate
//델리게이트 패턴을 통해 호출되어 실제로 구동되는 메소드
-(void)closeDelegateViewController:(UIViewController *)vc{
    NSLog(@"델리게이트 패턴 %@", vc);
    [delegateViewController.view removeFromSuperview];
}

-(void)changeViewColor:(UIViewController *)vc{
    NSLog(@"델리게이트 패턴 %@", vc);
    textLabel.backgroundColor = [self randomColor];
}

@end
