//
//  TPDelegateViewController.h
//  TestPattern
//
//  Created by lotco on 2016. 3. 16..
//  Copyright © 2016년 lotco. All rights reserved.
//

#import <UIKit/UIKit.h>

@protocol TPViewControllerDelegate;

@interface TPDelegateViewController : UIViewController
@property (nonatomic, weak) id<TPViewControllerDelegate> delegate;  //호출할 상위 객체의 포인터가 저장되는 변수
@end

@protocol TPViewControllerDelegate <NSObject>
@required
//필수적으로 들어가야만 되는 델리게이트
@optional
//선택적으로 들어가는 델리게이트
-(void)closeDelegateViewController:(UIViewController *)vc;
-(void)changeViewColor:(UIViewController *)vc;
@end